package com.vcarecity.publish.config;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.vcarecity.publish.entity.AgencyEntity;
import org.junit.jupiter.api.Test;

import java.lang.reflect.Type;
import java.util.Map;

class MapperConfigTest {
    @Test
    public void objectMapper() throws Exception {
        ObjectMapper objectMapper = new ObjectMapper();
        // objectMapper.setSerializationInclusion(JsonInclude.Include.NON_NULL);
        objectMapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);


        AgencyEntity ae = new AgencyEntity();
        ae.setAgencyId(11L);
        ae.setIsDeleted(0);

        String s = objectMapper.writeValueAsString(ae);
        System.out.println(s);

        Map<String, Object> map = objectMapper.convertValue(ae, new TypeReference<Map<String, Object>>() {
            @Override
            public Type getType() {
                return super.getType();
            }
        });
        System.out.println(map);

        String value = "{\"agencyId\":11,\"agencyPath\":null,\"agencyName\":null,\"isDeleted\":0}";

        AgencyEntity agencyEntity = objectMapper.readValue(value, AgencyEntity.class);
        System.out.println(agencyEntity);

    }
}